/*
    Stercus Accidit by Fit. This is the generic multiplatform source, not
    the Amiga-optimized one.
*/

#ifdef NOAMIKA
#include <SDL.h>
#include "cool_mzx/cool_mzx.h"
#else
#include "screen.h"
#include "theplayer.h"
#include "vbi.h"
#endif

#ifndef M_PI
#define M_PI 3.141492
#endif

#include <math.h>
#include "noise.h"
#include "halftone.h"
#include "wurms.h"
#include "maf.h"
#include "render.h"
#include "writer.h"

extern unsigned char    gargoyle[],kirkko[],skulle[],kirkko2[],
                        gargoyle2[],skulle2[],
                        nothing[],dracula[],greets[],kiehkura[],
                        etumehta[],takamehta[],
                        koottikarry1[],koottikarry2[],koottikarry3[],
                        marq[],man[],roz[],
                        pal_gray[],pal_red[],pal_blue[],pal_green[],
                        pal_yellow[],pal_black[],pal_white[],pal_gamma[],
                        rosic[],nosfe[],stercus[],drose[];

extern int              ch_a[],ch_m[],ch_i[],ch_k[],model1[];

extern unsigned short   gargoyletc[],kirkkotc[],skulletc[],kirkko2tc[],
                        gargoyle2tc[],skulle2tc[];

typedef struct writer_t {
    int x,y,num,
        start,duration,tid;
} WRITER;

typedef struct feidi_t {
    int start,duration,type;
    unsigned char *src,*dest;
    int tid;
} FEIDI;

volatile int tid=0;

#ifdef NOAMIKA
SDL_Surface *scr;
#else
void __interrupt __saveds int1(void)
{
    tid+=20;
}
void __interrupt __saveds int2(void)
{
    if(tid==-1)
        tid=0;
}
#endif

/* LSB <-> MSB 32-bit */
void swap(unsigned int *d,int units)
{
    int n;
    unsigned char *p=(unsigned char *)d,c;

    for(n=0;n<units;n++,p+=4)
    {
        c=p[0]; p[0]=p[3]; p[3]=c;
        c=p[1]; p[1]=p[2]; p[2]=c;
    }
}

/* LSB <-> MSB 16-bit */
void swamp(unsigned short *d,int units)
{
    int n;
    unsigned char *p=(unsigned char *)d,c;

    for(n=0;n<units;n++,p+=2)
    {
        c=p[0]; p[0]=p[1]; p[1]=c;
    }
}

#ifdef NOAMIKA
unsigned    plookup[256]={0};
unsigned    plookup2[256]={0};
void gfx_setcolor(int n,int r,int g,int b)
{
    r&=0xff; g&=0xff; b&=0xff;
    plookup[n]=SDL_MapRGB(scr->format,r,g,b);
    plookup2[n]=SDL_MapRGB(scr->format,r*4/5,g*4/5,b*4/5);
}
void gfx_setpalette(int first,int num,unsigned char *pal)
{
    int n;
    for(n=0;n<num;n++)
        gfx_setcolor(first+n,pal[n*3],pal[n*3+1],pal[n*3+2]);
}
#endif

int main(int argc,char *argv[])
{
    int quit=0,n,i,j,tmp,tid,pos,*letr,sn1,sn2,
        krollstart=-1,amistart=-1,hstart=-1,skullestart=-1,
        old=0,ran=0;
    static unsigned char buf[320*240],buf2[320*240],tex[256*256],palle[768];
    unsigned char *dest=buf,*p,*p2,*nakki;
    float letx[]={-2.2,-0.6,0.4,1.2,2.6};
    unsigned short *tc;

    WRITER wevent[]={
        {95,58, 0, 100,3000,-1},
        {70,58, 1, 132,3000, -1},
        {50,58, 2, 200,3000, -1},

        {-8,170, 3, 700,6000, -1},
        {-8,170, 4, 800,6000, -1},
        {-8,170, 5, 900,6000, -1},
        {-8,170, 6, 1000,6000, -1},

        {20,58, 7, 1132, 4000, -1},
        {40,58, 8, 1200, 4000, -1},
        {52,58, 9, 1232, 3000, -1},

        {-8,10, 11, 1300, 700, -1},
        {-8,32, 12, 1302, 700, -1},
        {-8,54, 13, 1304, 700, -1},
        {-8,76, 14, 1306, 700, -1},
        {-8,98, 11, 1316, 700, -1},
        {-8,120, 12, 1318, 700, -1},
        {-8,142, 13, 1320, 700, -1},
        {-8,164, 14, 1322, 700, -1},

        {-8,10, 11, 1400, 700, -1},
        {-8,32, 12, 1402, 700, -1},
        {-8,54, 13, 1404, 700, -1},
        {-8,76, 14, 1406, 700, -1},
        {-8,98, 11, 1416, 700, -1},
        {-8,120, 12, 1418, 700, -1},
        {-8,142, 13, 1420, 700, -1},
        {-8,164, 14, 1422, 700, -1},

        {-8,10, 11, 1500, 700, -1},
        {-8,32, 12, 1502, 700, -1},
        {-8,54, 13, 1504, 700, -1},
        {-8,76, 14, 1506, 700, -1},
        {-8,98, 11, 1516, 700, -1},
        {-8,120, 12, 1518, 700, -1},
        {-8,142, 13, 1520, 700, -1},
        {-8,164, 14, 1522, 700, -1},

        {-8,10, 11, 1600, 700, -1},
        {-8,32, 12, 1602, 700, -1},
        {-8,54, 13, 1604, 700, -1},
        {-8,76, 14, 1606, 700, -1},
        {-8,98, 11, 1616, 700, -1},
        {-8,120, 12, 1618, 700, -1},
        {-8,142, 13, 1620, 700, -1},
        {-8,164, 14, 1622, 700, -1},

        {-8,88, 19, 300, 4000, -1},
        {-8,88, 20, 400, 4000, -1},
        {-8,88, 21, 500, 2500, -1},
        {-8,88, 22, 532, 2500, -1},
        {-8,88, 21, 600, 2500, -1},
        {-8,88, 22, 632, 2500, -1},

        {92,1, 24, 2416, 4000, -1},

        {-12,58, 23, 2832,3000, -1},
        {108,58, 25, 2900,5000, -1},
        {0,0, 0, 0,0,-1}}; // End marker

    FEIDI fevent[]={
    {32,500,0, pal_black,pal_gray, -1},
    {100,2000,0, pal_gray,pal_red, -1},
    {132,2000,0, pal_red,pal_gray, -1},
    {200,2000,0, pal_gray,pal_yellow, -1},
    {220,500,0, pal_yellow,pal_black, -1},
    {232,300,0, pal_black,pal_gray, -1},
    {250,1000,0, pal_gray,pal_white, -1},

    {300,200,0, pal_white,pal_yellow, -1},

    {332,200,0, pal_yellow,pal_gamma, -1},
    {334,500,0, pal_gamma,pal_yellow, -1},
    {400,200,0, pal_yellow,pal_gamma, -1},
    {402,500,0, pal_gamma,pal_yellow, -1},
    {432,200,0, pal_yellow,pal_gamma, -1},
    {434,500,0, pal_gamma,pal_yellow, -1},

    {500,200,0, pal_yellow,pal_white, -1},
    {502,500,0, pal_white,pal_red, -1},
    {532,200,0, pal_red,pal_white, -1},
    {534,500,0, pal_white,pal_yellow, -1},
    {600,200,0, pal_yellow,pal_white, -1},
    {602,500,0, pal_white,pal_red, -1},
    {632,200,0, pal_red,pal_white, -1},
    {634,500,0, pal_white,pal_yellow, -1},
    {662,200,0, pal_white,pal_white, -1},

    {700,1000,0, pal_white,pal_yellow, -1},
    {900,200,0, pal_yellow,pal_white, -1},
    {902,1000,0, pal_white,pal_blue, -1},
    {1000,200,0, pal_blue,pal_white, -1},
    {1002,1000,0, pal_white,pal_yellow, -1},
    {1050,1000,0, pal_yellow,pal_black, -1},
    
    {1100,2000,0, pal_black, pal_red, -1},
    {1248,200,0, pal_red,pal_gamma, -1},
    {1250,500,0, pal_gamma,pal_yellow, -1},
    {1254,1000,0, pal_yellow,pal_black, -1},

    {1300,200,0, pal_black,pal_yellow, -1},
    {1432,200,0, pal_yellow,pal_gamma, -1},
    {1434,500,0, pal_gamma,pal_yellow, -1},
    {1462,200,0, pal_yellow,pal_black, -1},
    {1500,1000,0, pal_black,pal_green, -1},
    {1632,200,0, pal_green,pal_gamma, -1},
    {1634,500,0, pal_gamma,pal_green, -1},

    {1700,70,0, pal_green,pal_white, -1},
    {1702,800,0, pal_white,pal_red, -1},
    {1732,70,0, pal_red,pal_white, -1},
    {1734,800,0, pal_white,pal_blue, -1},

    {1900,2000,0, pal_blue,pal_green, -1},
    {2000,2000,0, pal_green,pal_gray, -1},
    {2100,2000,0, pal_gray,pal_yellow, -1},

    {2200,1000,0, pal_white,pal_green, -1},
    {2240,200,0, pal_green,pal_black, -1},
    {2242,100,0, pal_black,pal_blue, -1},
    {2318,100,0, pal_blue,pal_black, -1},
    {2320,500,0, pal_black,pal_gray, -1},

    {2400,6000,0, pal_gray,pal_yellow, -1},
    {2462,200,0, pal_yellow,pal_white, -1},
    {2500,2000,0, pal_white,pal_red, -1},
    {2600,7000,0, pal_red,pal_green, -1},
    {2732,1500,0, pal_green,pal_black, -1},

    {2800,500,0, pal_black,pal_green, -1},
    {2920,4000,0, pal_green,pal_black, -1},
    {0,0,0, NULL,NULL, -1}}; // End marker

#ifdef NOAMIKA
    SDL_Event e;
    int fullscreen=SDL_FULLSCREEN,origtime,*pix;
#endif

#ifdef NOAMIKA
    if(argc>=2)
        if(!strcmp(argv[1],"-w"))
            fullscreen=0;
    if(argv[0][strlen(argv[0])-1]=='w') // Windowed
            fullscreen=0;

    SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO|SDL_INIT_TIMER);
    scr=SDL_SetVideoMode(640,480,32,SDL_SWSURFACE|SDL_DOUBLEBUF|fullscreen);
    SDL_LockSurface(scr);
    memset(scr->pixels,0,640*480*4);
    SDL_UnlockSurface(scr);
    SDL_WM_SetCaption("Stercus Accidit",NULL);
    SDL_ShowCursor(0);

    ungetc('\n',stdin);
    ungetc('2',stdin);
    mzx_init(44100,BLKSIZE);
    mzx_get(nothing);

    halftone_init(320,200);
    wurms_init();
    init_maf();

#ifdef LSB
    /* Swap the byteorder from Amiga */
    swap(model1,11804/4);
    swap(ch_a,3680/4);
    swap(ch_m,2480/4);
    swap(ch_i,824/4);
    swap(ch_k,2120/4);
#else
    swamp(gargoyletc,128000/2);
    swamp(gargoyle2tc,128000/2);
    swamp(kirkkotc,128000/2);
    swamp(kirkko2tc,128000/2);
    swamp(skulletc,128000/2);
    swamp(skulle2tc,128000/2);
#endif

    mzx_start(54);
    while(mzx_position()<0 || mzx_position()>100) // Skip bug...
        ;
    origtime=SDL_GetTicks();
#else
    musa=theplayer_load("data/P61.dapope");
    gfx_init();
    theplayer_init(musa);
    VBI_install(int1,int2);
#endif

    for(n=0;n<256;n++)
        gfx_setpalette(0,256,pal_black);

    while(!quit)
    {
#ifdef NOAMIKA
        while(SDL_PollEvent(&e)>0)
        {
           if(e.type==SDL_KEYDOWN)
            if(e.key.keysym.sym==SDLK_ESCAPE)
                quit++;
        }
#else
        if(!(*((char *)0xbfe001)&64))
            quit=1;
#endif

#ifdef NOAMIKA
        tid=SDL_GetTicks()-origtime;
        pos=mzx_position();
#else
        pos=pt_songpos*100+pt_patternpos;
#endif

        /* Palette morphing */
        for(n=0;fevent[n].src!=NULL;n++)
        {
            if(pos>=fevent[n].start && fevent[n].tid==-1)
                fevent[n].tid=tid;
    
            if(fevent[n].tid>=0 && tid-fevent[n].tid<fevent[n].duration)
            {
                i=tid-fevent[n].tid;
                tmp=fevent[n].duration;
                for(j=0;j<768;j++)
                    palle[j]=fevent[n].src[j]*(tmp-i)/tmp+
                             fevent[n].dest[j]*i/tmp;

                gfx_setpalette(0,256,palle);
            }

            if(fevent[n].tid>=0 && tid-fevent[n].tid>=fevent[n].duration)
            {
                gfx_setpalette(0,256,fevent[n].dest);
                fevent[n].tid=-2;
            }
        }

        dest=buf;

        /* Start */
        if(pos<300)
        {
            if(pos<232)
            {
                memset(buf,0,320*200);
                i=tid/40%512;
                for(n=0;n<320;n++)
                {
                    for(j=0;j<80;j++)
                        buf[n+j*320+320*80]=koottikarry1[(j<<9)+(n+i&511)];
                }
            }
            else
                memcpy(buf,stercus,320*200);
        }

        /* Skulle */
        if(pos>=300 && pos<700)
        {
            if(skullestart==-1)
                skullestart=tid;

            if(pos>=648)
            {
                if(tid-old>30)
                {
                    ran=rand()%16;
                    old=tid;
                }

                i=pos-648;
                if(ran<i)
                {
                    memset(dest,0,320*200);
                    goto skip;
                }
            }

            tc=skulletc;
            nakki=skulle;
            if(pos>=500)
            {
                if(!(pos%100/32&1))
                {
                    tc=skulle2tc;
                    nakki=skulle2;
                }
            }

            p=kiehkura;
            sn1=(int)(100+sin(tid/50.0)*70.0);
            i=tid/20;

            if(tid-skullestart<256*40)
            {
                p=buf2;
                for(n=0;n<256;n++)
                    if(n+5<(tid-skullestart)/40)
                        memcpy(&p[255-n<<8],&kiehkura[255-n<<8],256);
                    else
                        memset(&p[255-n<<8],0,256);
            }

            for(n=0;n<320*200;n++)
                if(tc[n]==65535)
                    dest[n]=0;
                else
                {
                    tmp=nakki[n]*p[(tc[n]+(i<<8))&65535]/sn1+(nakki[n]>>2);
                    if(tmp>255)
                        tmp=255;
                    if(tmp<0)
                        tmp=0;
                    dest[n]=tmp;
                }
            skip:;
        }

        /* Forest Gump */
        if(pos>=700 && pos<1100)
        {
            i=tid/20%800;
            for(n=0;n<199;n++)
                memcpy(&buf[n*320],&takamehta[n*800+i],320);
    
            bare_clearzbuf();
            bare_loadidentity();

            if(pos<900)
            {
                for(n=0;n<256;n++)
                    buf2[n]=0;
            }
            if(pos>=900 && pos<1000)
            {
                for(n=0;n<256;n++)
                    buf2[n]=255;
            }
            if(pos>=1000)
            {
                for(n=0;n<256;n++)
                    if((1000000+n-tid/10)/12%16==0)
                        buf2[n]=255;
                    else
                        buf2[n]=0;
            }

            i=tid;
            //if((pos%100)/16&1)
                //i=tid+400;

            bare_translate(sin(tid/2000.0)*3,0,-19);
            bare_rotatey(i/1500.0);
            bare_rotatex(i/2013.0);
            bare_render(model1,buf,buf2);
    
            bare_loadidentity();
            bare_translate(sin(tid/2000.0+0.3)*2,0,-18.5);
            bare_rotatez(-i/1910.0);
            bare_rotatex(-i/1000.0);
            bare_render(model1,buf,buf2);
    
            i=tid/10%800;
            for(n=0;n<199;n++)
                for(j=0;j<320;j++)
                {
                    if(etumehta[n*800+i+j]!=255)
                    {
                        if(etumehta[n*800+i+j]==0)
                            buf[n*320+j]=0;
                        else
                            buf[n*320+j]=buf[n*320+j]*etumehta[n*800+i+j]>>8;
                    }
                }
    
            memset(&buf[320*199],0,320);
        }

        /* Stripe II (crap) */
        if(pos>=1100 && pos<1300)
        {
            memset(buf,0,320*200);
            i=tid/40%512;
            for(n=0;n<320;n++)
            {
                for(j=0;j<80;j++)
                    buf[n+j*320+320*80]=koottikarry3[(j<<9)+(n+i&511)];
            }
            wurms(buf,tid,16);
        }

        /* Gargoyle */
        if(pos>=1300 && pos<1800)
        {
            if(pos>=1748)
            {
                if(tid-old>30)
                {
                    ran=rand()%16;
                    old=tid;
                }

                i=pos-1748;
                if(ran<i)
                {
                    memset(dest,0,320*200);
                    goto skipz;
                }
            }

            p=kiehkura;
            i=(tid/9)*256+(int)(sin(tid/700.0)*40);
            j=(tid/11)*256+(int)(sin(tid/771.0)*40);
            sn1=(int)(120+sin(tid/150.0)*84.0);
            sn2=(int)(120+sin(tid/130.0)*84.0);

            nakki=gargoyle;
            tc=gargoyletc;
            if(pos>=1500)
            {
                nakki=gargoyle2;
                tc=gargoyle2tc;
            }

            for(n=0;n<320*200;n++)
                if(tc[n]==65535)
                    dest[n]=0;
                else
                {
                    tmp=(nakki[n]>>1)-
                        (p[(tc[n]+i)&0xffff]*sn1>>8)+
                        (p[65535-((tc[n]+j)&0xffff)]*sn2>>8);
                    if(tmp>255)
                        tmp=255;
                    if(tmp<0)
                        tmp=0;
                    dest[n]=tmp;
                }
            skipz:;
        }

        /* Amika */
        if(pos>=1800 && pos<2200)
        {
            if(amistart==-1)
                amistart=tid;

            memcpy(buf,drose,320*200);
            for(n=0;n<256;n++)
                if(n/4%16==0)
                    buf2[n]=240;
                else
                    buf2[n]=0;
    
            bare_clearzbuf();
    
            for(n=0;n<5;n++)
            {
                switch(n) {
                    case 0: letr=ch_a; break;
                    case 1: letr=ch_m; break;
                    case 2: letr=ch_i; break;
                    case 3: letr=ch_k; break;
                    case 4: letr=ch_a; break;
                }
        
                bare_loadidentity();
                i=tid-amistart;
                bare_translate(letx[n],-0.1+cos(i/400.0+n/3.0)*140.0/(30.0+(i/700.0)*(i/700.0)),-13);
                bare_rotatey((tid-n*80)/400.0);
                bare_rotatex(sin((tid+n*99)/990.0)/10.0);
    
                bare_render(letr,buf,buf2);
            }

            if(pos>=2000)
            {
                if(hstart==-1)
                    hstart=tid;
                memcpy(buf2,buf,320*200);
                j=pos-2000;
                i=(j/100*64+j%100)/16*80+(tid-hstart)/80;
                halftone(buf2,buf,i);
                dest=buf2;
            }

            for(n=0;n<320*200;n++)
                if(rosic[n]!=255)
                    dest[n]=rosic[n];
        }

        /* Credits */
        if(pos>=2200 && pos<2400)
        {
            if(pos<2242)
                memcpy(dest,marq,320*200);
            if(pos>=2242 && pos<2320)
                memcpy(dest,man,320*200);
            if(pos>=2320)
                memcpy(dest,roz,320*200);
            wurms2(dest,tid,8);
            if(pos%100/4&1)
            {
                if(pos<2242)
                    writer2(buf,0,0,60);
                if(pos>=2242 && pos<2320)
                    writer2(buf,1,0,60);
                if(pos>=2320)
                    writer2(buf,2,0,60);
            }
        }

        /* Church (kyrka) */
        if(pos>=2400 && pos<2800)
        {
            if(pos>=2500 && krollstart==-1)
                krollstart=tid;

            p=&greets[((tid-krollstart)/20)%999*256+(int)(sin(tid/500.0)*30)];
            p2=&greets[((tid-krollstart-200)/20)%999*256+(int)(0.2+sin(tid/500.0)*20)];
            if(pos<2500)
                p=&dracula[tid/100%29*256*256];

            nakki=kirkko;
            tc=kirkkotc;
            if(pos>=2500 && pos%100/16&1)
            {
                nakki=kirkko2;
                tc=kirkko2tc;
            }
            
            i=(tid/9)*256+(int)(sin(tid/700.0)*40);
            j=(tid/11)*256+(int)(sin(tid/771.0)*40);
            sn1=(int)(120+sin(tid/150.0)*84.0);
            sn2=(int)(120+sin(tid/130.0)*84.0);

            if(pos<2500)
            {
                for(n=0;n<320*200;n++)
                    if(tc[n]==65535)
                        dest[n]=0;
                    else
                    {
                        tmp=(nakki[n]>>1)+
                            (p[tc[n]]*sn1>>6);
                        if(tmp>255)
                            tmp=255;
                        if(tmp<0)
                            tmp=0;
                        dest[n]=tmp;
                    }
            }
            else
            {
                for(n=0;n<320*200;n++)
                    if(tc[n]==65535)
                        dest[n]=0;
                    else
                    {
                        tmp=(nakki[n]>>1)-
                            (p2[tc[n]]*sn2>>9)+
                            ((p[tc[n]]*sn1)>>7);
                        if(tmp>255)
                            tmp=255;
                        if(tmp<0)
                            tmp=0;
                        dest[n]=tmp;
                    }
            }

            sade(dest,tid);
        }

        /* The end */
        if(pos>=2800 && pos<3000)
        {
            memset(buf,0,320*200);
            i=tid/40%512;
            for(n=0;n<320;n++)
            {
                for(j=0;j<80;j++)
                    buf[n+j*320+320*80]=koottikarry2[(j<<9)+(n+i&511)];
            }
        }

        for(n=0;wevent[n].duration;n++)
        {
            if(pos>=wevent[n].start && wevent[n].tid==-1)
                wevent[n].tid=tid;
    
            if(wevent[n].tid!=-1 && tid-wevent[n].tid<wevent[n].duration)
            {
                i=tid-wevent[n].tid;
                j=1;
                if(i<200)
                    j=32-i*31/200;
                if(i>wevent[n].duration-300)
                    j=(300-(wevent[n].duration-i))*32/300;
                writer(dest,wevent[n].num,wevent[n].x,wevent[n].y,j);
            }
        }

        //writer(buf,tid/800%26,0,48,fabs(sin(3.141592*2*tid/1600.0))*15.0);

/*        if(1)//tid/200&1)
        {
            memset(buf2,0,320*200);
            //memcpy(buf2,buf,320*200);
            halftone(buf2,buf,400+sin(tid/300.0)*400);
            dest=buf2;
        }*/

        noise(dest,tid/20);

#ifdef NOAMIKA
        SDL_LockSurface(scr);
        pix=scr->pixels;
        for(n=0;n<200;n++)
        {
            tmp=(20+n)*1280;
            for(i=0;i<320;i++,tmp+=2)
            {
                pix[tmp]=pix[tmp+1]=plookup[dest[n*320+i]];
                pix[tmp+640]=pix[tmp+641]=plookup2[dest[n*320+i]];
            }
        }
        SDL_UnlockSurface(scr);
        SDL_Flip(scr);
#else
        gfx_blit(dest, 0,28, 320,200);
#endif

        if(pos>=3000)
            quit=1;        
    }

#ifdef NOAMIKA
    SDL_Quit();
#else
    theplayer_end();
    theplayer_free(musa);
    VBI_remove();
    gfx_close();
#endif
    return(0);
}
